PIRL.Viewers

## Class URL_Dialog

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - java.awt.Window
      - - java.awt.Dialog
        - - javax.swing.JDialog
          - - PIRL.Viewers.URL_Dialog

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, Accessible, RootPaneContainer, WindowConstants

    public class URL_Dialog
    extends JDialog

URL_Dialog provides a dialog used to interactively obtain the information needed to construct a URL.

URL_Dialog is a reusable dialog. Once constructed it only needs to be setVisible to be activated. If it had been used previously the previous field values that were accepted will remain. The current URL definition is renewed when the Accept button is pressed and the information is valid. To be valid, the Protocol and Hostname fields must not be empty and the Port number field must either be empty or an integer number. The default protocol is http, but may be overridden.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class javax.swing.JDialog

`JDialog.AccessibleJDialog`

### Nested classes/interfaces inherited from class java.awt.Dialog

`Dialog.AccessibleAWTDialog, Dialog.ModalExclusionType, Dialog.ModalityType`

### Nested classes/interfaces inherited from class java.awt.Window

`Window.AccessibleAWTWindow, Window.Type`

### Nested classes/interfaces inherited from class java.awt.Container

`Container.AccessibleAWTContainer`

### Nested classes/interfaces inherited from class java.awt.Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`

### Field Summary

Fields
`static String` `DEFAULT_PROTOCOL` Default protocol.
`static String` `ID` Class name and version identification.

### Fields inherited from class javax.swing.JDialog

`accessibleContext, rootPane, rootPaneCheckingEnabled`

### Fields inherited from class java.awt.Dialog

`DEFAULT_MODALITY_TYPE`

### Fields inherited from class java.awt.Component

`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

### Fields inherited from interface javax.swing.WindowConstants

`DISPOSE_ON_CLOSE, DO_NOTHING_ON_CLOSE, EXIT_ON_CLOSE, HIDE_ON_CLOSE`

### Fields inherited from interface java.awt.image.ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

### Constructor Summary

Constructors
Constructor and Description
`URL_Dialog()` Constructs a default URL_Dialog.
`URL_Dialog(boolean modal)` Constructs a URL_Dialog.
`URL_Dialog(String title, boolean modal)` Constructs a URL_Dialog.
`URL_Dialog(String title, Icon icon, boolean modal)` Constructs a URL_Dialog.
`URL_Dialog(String title, Icon icon, Frame owner, boolean modal)` Constructs a URL_Dialog.

### Method Summary

Methods
`void` `Clear()` Clears the fields.
`URL` `Current_URL()` Get the current URL.
`static String` `Default_Protocol()` Get the default protocol.
`static void` `Default_Protocol(String protocol)` Set the default protocol.
`static URL` `Get_URL()` Get a URL.
`static URL` `Get_URL(String title, Icon icon, JFrame parent)` Get a URL.
`URL_Dialog` `Hostname(String hostname)` Set the Hostname field entry.
`static void` `main(String[] arguments)`
`URL_Dialog` `Pathname(String pathname)` Set the Pathname field entry.
`URL_Dialog` `Port_Number(int port)` Set the Port number field entry.
`URL_Dialog` `Protocol(String protocol)` Set the Protocol field entry.

### Methods inherited from class javax.swing.JDialog

`addImpl, createRootPane, dialogInit, getAccessibleContext, getContentPane, getDefaultCloseOperation, getGlassPane, getGraphics, getJMenuBar, getLayeredPane, getRootPane, getTransferHandler, isDefaultLookAndFeelDecorated, isRootPaneCheckingEnabled, paramString, processWindowEvent, remove, repaint, setContentPane, setDefaultCloseOperation, setDefaultLookAndFeelDecorated, setGlassPane, setJMenuBar, setLayeredPane, setLayout, setRootPane, setRootPaneCheckingEnabled, setTransferHandler, update`

### Methods inherited from class java.awt.Dialog

`addNotify, getModalityType, getTitle, hide, isModal, isResizable, isUndecorated, setBackground, setModal, setModalityType, setOpacity, setResizable, setShape, setTitle, setUndecorated, setVisible, show, toBack`

### Methods inherited from class java.awt.Window

`addPropertyChangeListener, addPropertyChangeListener, addWindowFocusListener, addWindowListener, addWindowStateListener, applyResourceBundle, applyResourceBundle, createBufferStrategy, createBufferStrategy, dispose, getBackground, getBufferStrategy, getFocusableWindowState, getFocusCycleRootAncestor, getFocusOwner, getFocusTraversalKeys, getIconImages, getInputContext, getListeners, getLocale, getModalExclusionType, getMostRecentFocusOwner, getOpacity, getOwnedWindows, getOwner, getOwnerlessWindows, getShape, getToolkit, getType, getWarningString, getWindowFocusListeners, getWindowListeners, getWindows, getWindowStateListeners, isActive, isAlwaysOnTop, isAlwaysOnTopSupported, isAutoRequestFocus, isFocusableWindow, isFocusCycleRoot, isFocused, isLocationByPlatform, isOpaque, isShowing, isValidateRoot, pack, paint, postEvent, processEvent, processWindowFocusEvent, processWindowStateEvent, removeNotify, removeWindowFocusListener, removeWindowListener, removeWindowStateListener, reshape, setAlwaysOnTop, setAutoRequestFocus, setBounds, setBounds, setCursor, setFocusableWindowState, setFocusCycleRoot, setIconImage, setIconImages, setLocation, setLocation, setLocationByPlatform, setLocationRelativeTo, setMinimumSize, setModalExclusionType, setSize, setSize, setType, toFront`

### Methods inherited from class java.awt.Container

`add, add, add, add, add, addContainerListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getAlignmentX, getAlignmentY, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalPolicy, getInsets, getLayout, getMaximumSize, getMinimumSize, getMousePosition, getPreferredSize, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, print, printComponents, processContainerEvent, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusTraversalKeys, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setFont, transferFocusDownCycle, validate, validateTree`

### Methods inherited from class java.awt.Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, disable, disableEvents, dispatchEvent, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocation, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, prepareImage, prepareImage, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resize, resize, revalidate, setComponentOrientation, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeysEnabled, setForeground, setIgnoreRepaint, setLocale, setMaximumSize, setName, setPreferredSize, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Field Detail

#### ID

    public static final String ID

Class name and version identification.

See Also:
  Constant Field Values

#### DEFAULT_PROTOCOL

    public static final String DEFAULT_PROTOCOL

Default protocol.

See Also:
  Constant Field Values

### Constructor Detail

#### URL_Dialog

    public URL_Dialog(String title,
              Icon icon,
              Frame owner,
              boolean modal)

Constructs a URL_Dialog.

Parameters:
  `title` - The title String for the dialog window.
  `icon` - The Icon to be displayed on the dialog. If null no Icon is displayed.
  `owner` - The Frame with which the dialog is associated, which may be null.
  `modal` - If true, the dialog will be modal; if false, the dialog will not be modal.

#### URL_Dialog

    public URL_Dialog(String title,
              Icon icon,
              boolean modal)

Constructs a URL_Dialog.

Parameters:
  `title` - The title String for the dialog window.
  `icon` - The Icon to be displayed on the dialog. If null no Icon is displayed.
  `modal` - If true, the dialog will be modal; if false, the dialog will not be modal.

#### URL_Dialog

    public URL_Dialog(String title,
              boolean modal)

Constructs a URL_Dialog.

Parameters:
  `title` - The title String for the dialog window.
  `modal` - If true, the dialog will be modal; if false, the dialog will not be modal.

#### URL_Dialog

    public URL_Dialog(boolean modal)

Constructs a URL_Dialog.

Parameters:
  `modal` - If true, the dialog will be modal; if false, the dialog will not be modal.

#### URL_Dialog

    public URL_Dialog()

Constructs a default URL_Dialog.

### Method Detail

#### Get_URL

    public static URL Get_URL(String title,
              Icon icon,
              JFrame parent)

Get a URL.

A modal URL_Dialog is constructed from which to obtain a URL.

Parameters:
  `title` - The title String for the dialog window.
  `icon` - The Icon to be displayed on the dialog. If null no Icon is displayed.
  `parent` - The parent window that dialog is associated with, which may be null.
Returns:
  A URL constructed from the information obtained. This will be null if the user Canceled the dialog.

#### Get_URL

    public static URL Get_URL()

Get a URL.

A default URL_Dialog is used to obtain a URL.

Returns:
  A URL constructed from the information obtained. This will be null if the user Canceled the dialog.
See Also:
  `Get_URL(String, Icon, JFrame)`

#### Current_URL

    public URL Current_URL()

Get the current URL.

The current URL is produced after each successful accept action.

Returns:
  The current URL. This wil be null if no URL has yet been constructed.

#### Default_Protocol

    public static String Default_Protocol()

Get the default protocol.

Returns:
  The default protocol String.

#### Default_Protocol

    public static void Default_Protocol(String protocol)

Set the default protocol.

Trailing "://" characters are stripped off.

Parameters:
  `protocol` - The default protocol String. A null or empty value will set the `DEFAULT_PROTOCOL`.

#### Protocol

    public URL_Dialog Protocol(String protocol)

Set the Protocol field entry.

Trailing "://" characters are stripped off.

Parameters:
  `protocol` - The default protocol String. A null or empty value will set the `DEFAULT_PROTOCOL`.
Returns:
  This URL_Dialog.

#### Hostname

    public URL_Dialog Hostname(String hostname)

Set the Hostname field entry.

Parameters:
  `hostname` - The hostname String.
Returns:
  This URL_Dialog.

#### Port_Number

    public URL_Dialog Port_Number(int port)

Set the Port number field entry.

Parameters:
  `port` - The port number. A negative value clears the field.
Returns:
  This URL_Dialog.

#### Pathname

    public URL_Dialog Pathname(String pathname)

Set the Pathname field entry.

Parameters:
  `pathname` - The pathname String.
Returns:
  This URL_Dialog.

#### Clear

    public void Clear()

Clears the fields.

The Protocol field will be reset to the `default` value.

#### main

    public static void main(String[] arguments)